-- BandwidthTotal.lua
-- 42dorian
-- Feb 2011

--Insert into Conky when Ready:
--lua_load /home/dorian/Conky/Scripts/BandwidthTotal.lua
--lua_draw_hook_pre conky_draw_vnring

require 'cairo'
function string:split(delimiter)
local result = { }
local from  = 1
local delim_from, delim_to = string.find( self, delimiter, from  )
while delim_from do
table.insert( result, string.sub( self, from , delim_from-1 ) )
from  = delim_to + 1
delim_from, delim_to = string.find( self, delimiter, from  )
end
table.insert( result, string.sub( self, from  ) )
return result
end

function draw_ring(co, across, down, rad, inlw, rstart, rend, bgr, bgg, bgb, bga, inr, ing, inb, ina)
local angle_0=rstart*(2*math.pi/360)-math.pi/2
local angle_f=rend*(2*math.pi/360)-math.pi/2
local t_arc=(co/100)*(angle_f-angle_0)
-- Draw background ring
cairo_arc(cr,across,down,rad,angle_0,angle_f)
cairo_set_source_rgba(cr,bgr,bgg,bgb,bga)
cairo_set_line_width(cr,inlw)
cairo_stroke(cr)
-- Draw indicator ring
cairo_arc(cr,across,down,rad,angle_0,angle_0+t_arc)
cairo_set_source_rgba(cr,inr,ing,inb,ina)
cairo_stroke(cr)
end

function conky_draw_vnring()
if conky_window == nil then return end
local cs = cairo_xlib_surface_create(conky_window.display, conky_window.drawable, conky_window.visual, conky_window.width, conky_window.height)
cr = cairo_create(cs)
local updates=tonumber(conky_parse('${updates}'))

if updates> 5 then
--RING 1 SETUP-----------------------------------------------------------------------------
--conky object to be displayed-----
wtimer=(updates % 30)+1
months = {"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"}
monthnum=tonumber(os.date('%m'))
monthname=os.date('%b')
day=tonumber(os.date('%d'))
if day<12 then
    if monthnum==1 then
    monthbeforenum=12
    else
    monthbeforenum=monthnum-1
    end
month=months[monthbeforenum]
else
month=monthname
end
if updates==6 or wtimer==1 then
co=(conky_parse("${exec vnstat -m | grep -n '" .. month .. "' | sed -n 1p | awk -F'|' '{print $3}'}"))
co=string.gsub(co," ","")
num=tonumber((string.gsub(co,"%a","")))
units=(string.gsub(co,"[%p%d]",""))
end
if num==nil then num=0 end
print (num,units)
--max number--------------------------
if units=="GB" then max=25 end
if units =="MB" then max=25600 end
if units =="KB" then max=26214400 end
if max==nil then max=0 end
--position-----------------------------
across=275
down=210
--radius of ring-----------------------
rad=25
--ring width---------------------------
inlw=15
--start and end angles---------------
rstart=-135
rend=135
--color and alpha for indicator----
inr,ing,inb,ina=255,0,0,1
--background ring color and alpha-----
bgr,bgg,bgb,bga=255,255,0,1
--calculation, do not edit below---------
co=(num/max)*100
draw_ring(co, across, down, rad, inlw, rstart, rend, bgr, bgg, bgb, bga, inr, ing, inb, ina)
--END RING 1 SETUP---------------copy setup section and paste for additional rings----------
end
end